#!/bin/bash
osascript -l JavaScript <<JXA_END 2>/dev/null
(function gather(lstRecipes) {
	"use strict";

	function xpathHarvest(strXPath) {
		function attribs(oElem) {
			var dctProps = {},
				varText, i;

			if (oElem.hasAttributes()) {
				var attrs = oElem.attributes,
					i = attrs.length,
					oAttr;

				dctProps['text'] = oElem.text ||
					oElem.textContent.replace(/\s{2,}/g, ' ') || '';
				while (i--) {
					oAttr = attrs[i];
					dctProps[oAttr.name] = oAttr.value;
				}
			}
			return dctProps;
		}

		var r = document.evaluate(strXPath, document, null, 0, null),
			lst = [],
			oNode;
		while (oNode = r.iterateNext()) lst.push(attribs(oNode));
		return lst;
	}


	// xpath --> string that should be in url --> page type description string
	function pageXPathResult(strXPath) {
		return (oDoc) ? appSafari.doJavaScript(
			"(" + xpathHarvest.toString() + ")(\"" + strXPath + "\")", { in : oWin.currentTab
			}
		) : "No Safari page open";
	}


	// length of longest stretch of matching characters
	// str --> str --> integer
	function matchScore(strSample, strPattern) {
		var i = 0,
			lngStretch = 0,
			lngMax = 0,
			strChar, strPair;
		while ((strChar = strSample[i]) && (strPair = strPattern[i])) {
			if (strChar === strPair) {
				lngStretch += 1;
				if (lngStretch > lngMax) lngMax = lngStretch;
			} else lngStretch = 0;
			i++;
		}
		return lngMax;
	}

	/// MAIN

	// Get the url of the front tab
	var appSafari = Application("Safari"),
		lstDocs = appSafari.documents(),
		lstWins = appSafari.windows(),
		oDoc = lstDocs.length ? lstDocs[0] : null,
		strActiveURL = oDoc ? oDoc.url() : '',
		oWin = lstWins.length ? lstWins[0] : null,
		lngRecipe = lstRecipes.length,
		i = lngRecipe,
		iMatch = -1,
		lngMax = -1,
		lngScore;

	var dctGeneric = {
		title: "All links on page",
		xpath: "//a",
		lambdaxjs: "'- [' + ((x.text && x.text.length > 1) ? x.text : x.href) + '](' + x.href + ')'"
	};

	// find the best url match among the list recipes
	while (i--) {
		lngScore = matchScore(strActiveURL, lstRecipes[i].baseURL);
		if (lngScore > lngMax) {
			iMatch = i;
			lngMax = lngScore;
		}
	}

	iMatch = (lngMax > 8) ? iMatch : null;

	var //app = Application.currentApplication(),
		dctRecipe = (iMatch !== null) ? lstRecipes[iMatch] : dctGeneric,
		varResult = pageXPathResult(dctRecipe.xpath),
		oFn = eval(
			"(function () { return function (x) {return " + dctRecipe.lambdaxjs +
			";};})()"
		),
		strResult = (typeof varResult === 'string') ?
		varResult :
		varResult.map(oFn).join("\n");

	strResult = (strResult.length) ?
		"## " + dctRecipe.title + "\n\n" + strResult :
		"No " + dctRecipe.title + " found by searching for: " + dctRecipe.xpath +
		" in:\n" + strActiveURL;

	// app.includeStandardAdditions = true;
	// app.setTheClipboardTo(strResult);

	return strResult;
})($(<linkPatterns.json));
JXA_END