#!/bin/bash

xpath_pattern="//*[@class='r']/a"
check_pattern="Google"
descrip_pattern="Google search results page"
jsx_lambda="'- [' + x.text + '](' + x.href + ')'"

osascript -l JavaScript <<JXA_END 2>/dev/null
(function gather(strXPath, strCheck, strDescrip) {
	function xpathHarvest(strXPath) {
		function attribs(oElem) {
			var dctProps = {};

			if (oElem.hasAttributes()) {
				var attrs = oElem.attributes,
					i = attrs.length,
					oAttr;

				dctProps['text'] = oElem.text;
				while (i--) {
					oAttr = attrs[i];
					dctProps[oAttr.name] = oAttr.value;
				}
			}
			return dctProps;
		}
		
		var r = document.evaluate(strXPath, document, null, 0, null),
			lst = [],
			oNode;
		while (oNode = r.iterateNext()) {
			lst.push(attribs(oNode));
		}
		return lst;
	}


	// xpath --> string that should be in url --> page type description string
	function pageXPathResult(strXPath, strURLCheck, strDescrip) {
		
		var appSafari = Application("Safari"),
			lstDocs = appSafari.documents(),
			lstWins = appSafari.windows(),
			oDoc = lstDocs.length ? lstDocs[0] : null,
			oWin = lstWins.length ? lstWins[0] : null,
			strName = oWin.name(),
			strJS = "(" + xpathHarvest.toString() + ")(" + strXPath + ")";
	   
		if (oDoc && (oWin.name().indexOf(strURLCheck) !== -1)) {
			return appSafari.doJavaScript(
				strJS, { in : appSafari.windows[0].currentTab}
			);
		 } else return  "Not a " + strDescrip + ":\n" + oDoc.url();
	}
	
	var app = Application.currentApplication(),
		varResult = pageXPathResult(strXPath, strCheck, strDescrip),
		strResult = (typeof varResult === 'string') ?
		varResult :
		varResult.map(function (x) {
			return $jsx_lambda;
		}).join("\n");

	app.includeStandardAdditions = true;
	app.setTheClipboardTo(strResult);

	return strResult;
})("\"$xpath_pattern\"", "$check_pattern", "\"$descrip_pattern\"");
JXA_END