// Google only

function run() {
  "use strict";

  // Harvest elements from Safari by XPath pattern
  function pageXPathHarvest(strXPath) {
    var lstWins = appSafari.windows(),
      oWin = lstWins.length ? lstWins[0] : null;

    return (oWin) ? appSafari.doJavaScript(
      "(" + xpathHarvest.toString() + ")(\"" + strXPath + "\")", { in
          : oWin.currentTab
      }
    ) : "No Safari page open";
  }

  // Harvesting function to run in the browser context
  function xpathHarvest(strPath) {
    var r = document.evaluate(strPath, document, null, 0, null),
      lst = [],
      oNode;

    while (oNode = r.iterateNext()) {
      lst.push([oNode.text, oNode.href]);
    }
    return lst;
  }

  // MAIN
  var appSafari = Application("Safari"),
    app = Application.currentApplication();

  app.includeStandardAdditions = true;

  // Gather any results as [ text ]( href ) Markdown links
  var strGoogleResultPath = "//*[@class='r']/a",
    lstLinks = pageXPathHarvest(strGoogleResultPath),
    blnFound = lstLinks.length,
    strResult = blnFound ?
    lstLinks.reduce(function (strAccum, lstTextLink) {
      return strAccum + '[' + lstTextLink[0] + '](' + lstTextLink[1] + ')\n';
    }, '') :
    'No matching links matching "' + strGoogleResultPath + '" found',
    strCmd;

  //  open each link in a browser tab
  if (blnFound) {
    strCmd = lstLinks.reduce(
      function (strAccum, lstTextLink) {
        return strAccum + 'open "' + lstTextLink[1] + '"\n';
      },
      ''
    )
    app.doShellScript(strCmd);
  }

  // and pass labelled links on in Markdown format
  return strResult;
}